/* 
 Copyright (c) 2013 LDBC
 Linked Data Benchmark Council (http://www.ldbcouncil.org)
 
 This file is part of ldbc_snb_datagen.
 
 ldbc_snb_datagen is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 ldbc_snb_datagen is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with ldbc_snb_datagen.  If not, see <http://www.gnu.org/licenses/>.
 
 Copyright (C) 2011 OpenLink Software <bdsmt@openlinksw.com>
 All Rights Reserved.
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation;  only Version 2 of the License dated
 June 1991.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.*/
package ldbc.snb.datagen.entities.dynamic.person.similarity;

import ldbc.snb.datagen.entities.dynamic.person.Person;

import java.util.Set;
import java.util.TreeSet;

public class InterestsSimilarity implements Person.PersonSimilarity {
    public float similarity(Person personA, Person personB) {
        Set<Integer> union = new TreeSet<>(personA.getInterests());
        union.addAll(personB.getInterests());
        union.add(personA.getMainInterest());
        union.add(personB.getMainInterest());
        Set<Integer> intersection = new TreeSet<>(personA.getInterests());
        intersection.retainAll(personB.getInterests());
        if (personA.getMainInterest() == personB.getMainInterest()) intersection.add(personA.getMainInterest());
        return union.size() > 0 ? intersection.size() / (float) union.size() : 0;
    }
}
